/////////////////////////////////////////////////////////////////////////////
//  File:       FormulaSettingsDlg.cpp
//  Version:    1.0.0.0
//  Created:    03-april-2002
//
//  Author:     Thorsten Wack
//  E-mail:     wt@umsicht.fhg.de
//
//
// This code may be used in compiled form in any way you desire. This
// file may be redistributed unmodified by any means PROVIDING it is 
// not sold for profit without the authors written consent, and 
// providing that this notice and the authors name is included. If 
// the source code in  this file is used in any commercial application 
// then a simple email would be nice.
//
// This file is provided "as is" with no expressed or implied warranty.
// The author accepts no liability if it causes any damage whatsoever.
//
/////////////////////////////////////////////////////////////////////////////


#include "stdafx.h"
#include "resource.h"
#include "FormulaSettingsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFormulaSettingsDlg dialog


CFormulaSettingsDlg::CFormulaSettingsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFormulaSettingsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFormulaSettingsDlg)
	//}}AFX_DATA_INIT
}

void CFormulaSettingsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFormulaSettingsDlg)
	DDX_Control(pDX, IDC_COMBO_FONT_VAR, m_ComboFontVar);
	DDX_Control(pDX, IDC_COMBO_FONT_CONST, m_ComboFontConst);
	DDX_Control(pDX, IDC_COMBO_FONT_NUM, m_ComboFontNum);
	DDX_Control(pDX, IDC_COMBO_FONT_FUNC, m_ComboFontFunc);
	DDX_Control(pDX, IDC_COLOR_VAR, m_ColourPickerVar);
	DDX_Control(pDX, IDC_COLOR_CONST, m_ColourPickerConst);
	DDX_Control(pDX, IDC_COLOR_NUM, m_ColourPickerNum);
	DDX_Control(pDX, IDC_COLOR_FUNC, m_ColourPickerFunc);
	//}}AFX_DATA_MAP
    DDX_Control(pDX, IDC_CUSTOM_PREVIEW, m_PreviewCtrl);

	DDX_ColourPicker(pDX, IDC_COLOR_VAR, m_BinTreeFormat.m_pFormatVar->m_crColor);
	DDX_ColourPicker(pDX, IDC_COLOR_CONST, m_BinTreeFormat.m_pFormatConst->m_crColor);
	DDX_ColourPicker(pDX, IDC_COLOR_NUM,	m_BinTreeFormat.m_pFormatNum->m_crColor);
	DDX_ColourPicker(pDX, IDC_COLOR_FUNC, m_BinTreeFormat.m_pFormatFunc->m_crColor);

	DDX_Check(pDX, IDC_CHECK_BOLD_VAR, m_BinTreeFormat.m_pFormatVar->m_bBold);
	DDX_Check(pDX, IDC_CHECK_BOLD_CONST, m_BinTreeFormat.m_pFormatConst->m_bBold);
	DDX_Check(pDX, IDC_CHECK_BOLD_NUM, m_BinTreeFormat.m_pFormatNum->m_bBold);
	DDX_Check(pDX, IDC_CHECK_BOLD_FUNC, m_BinTreeFormat.m_pFormatFunc->m_bBold);

	DDX_Check(pDX, IDC_CHECK_ITALIC_VAR, m_BinTreeFormat.m_pFormatVar->m_bItalic);
	DDX_Check(pDX, IDC_CHECK_ITALIC_CONST, m_BinTreeFormat.m_pFormatConst->m_bItalic);
	DDX_Check(pDX, IDC_CHECK_ITALIC_NUM, m_BinTreeFormat.m_pFormatNum->m_bItalic);
	DDX_Check(pDX, IDC_CHECK_ITALIC_FUNC, m_BinTreeFormat.m_pFormatFunc->m_bItalic);
	
	DDX_Text(pDX, IDC_EDIT_STANDARD, m_BinTreeFormat.m_nFontHeight[FH_STANDARD]);
	DDV_MinMaxInt(pDX, m_BinTreeFormat.m_nFontHeight[FH_STANDARD], 0, 20);

	DDX_Text(pDX, IDC_EDIT_SUB, m_BinTreeFormat.m_nFontHeight[FH_SUB]);
	DDV_MinMaxInt(pDX, m_BinTreeFormat.m_nFontHeight[FH_SUB], 0, 20);
	
	DDX_Text(pDX, IDC_EDIT_SUB_SUB, m_BinTreeFormat.m_nFontHeight[FH_SUB_SUB]);
	DDV_MinMaxInt(pDX, m_BinTreeFormat.m_nFontHeight[FH_SUB_SUB], 0, 20);
	
	DDX_Text(pDX, IDC_EDIT_SYMBOL, m_BinTreeFormat.m_nFontHeight[FH_SYMBOL]);
	DDV_MinMaxInt(pDX, m_BinTreeFormat.m_nFontHeight[FH_SYMBOL], 0, 20);
	
	DDX_Text(pDX, IDC_EDIT_SUB_SYMBOL, m_BinTreeFormat.m_nFontHeight[FH_SUB_SYMBOL]);
	DDV_MinMaxInt(pDX, m_BinTreeFormat.m_nFontHeight[FH_SUB_SYMBOL], 0, 20);
}


BEGIN_MESSAGE_MAP(CFormulaSettingsDlg, CDialog)
	//{{AFX_MSG_MAP(CFormulaSettingsDlg)
	ON_BN_CLICKED(IDC_CHECK_ITALIC_CONST, UpdatePreview)
	ON_BN_CLICKED(IDC_CHECK_ITALIC_VAR, UpdatePreview)
	ON_BN_CLICKED(IDC_CHECK_ITALIC_NUM, UpdatePreview)
	ON_BN_CLICKED(IDC_CHECK_ITALIC_FUNC, UpdatePreview)
	ON_BN_CLICKED(IDC_CHECK_BOLD_CONST, UpdatePreview)
	ON_BN_CLICKED(IDC_CHECK_BOLD_VAR, UpdatePreview)
	ON_BN_CLICKED(IDC_CHECK_BOLD_NUM, UpdatePreview)
	ON_BN_CLICKED(IDC_CHECK_BOLD_FUNC, UpdatePreview)
	ON_CBN_SELCHANGE(IDC_COMBO_FONT_CONST, UpdatePreview)
	ON_CBN_SELCHANGE(IDC_COMBO_FONT_VAR, UpdatePreview)
	ON_CBN_SELCHANGE(IDC_COMBO_FONT_NUM, UpdatePreview)
	ON_CBN_SELCHANGE(IDC_COMBO_FONT_FUNC, UpdatePreview)
	ON_EN_KILLFOCUS(IDC_EDIT_STANDARD, OnKillfocusEdit)
	ON_EN_KILLFOCUS(IDC_EDIT_SUB, OnKillfocusEdit)
	ON_EN_KILLFOCUS(IDC_EDIT_SUB_SUB, OnKillfocusEdit)
	ON_EN_KILLFOCUS(IDC_EDIT_SYMBOL, OnKillfocusEdit)
	ON_EN_KILLFOCUS(IDC_EDIT_SUB_SYMBOL, OnKillfocusEdit)
	//}}AFX_MSG_MAP
    ON_MESSAGE(CPN_SELENDOK,  OnSelEndOK)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFormulaSettingsDlg message handlers

BOOL CFormulaSettingsDlg::OnInitDialog() 
{
	SetupPreviewTree();
	m_PreviewCtrl.SetBinTree(&m_BinTree);

	CDialog::OnInitDialog();

	// init the controls, if you dont want to use the fonts 
	// in the comboboxes, try SetUseFont(FALSE);
	m_ComboFontVar.FillFonts();
	m_ComboFontVar.SetUseFont(FALSE);
	m_ComboFontConst.FillFonts();
	m_ComboFontConst.SetUseFont(FALSE);
	m_ComboFontNum.FillFonts();
	m_ComboFontNum.SetUseFont(FALSE);
	m_ComboFontFunc.FillFonts();
	m_ComboFontFunc.SetUseFont(FALSE);

	// select the current font in the data structure
	m_ComboFontVar.SelectString(-1, m_BinTreeFormat.m_pFormatVar->m_strFaceName);
	m_ComboFontConst.SelectString(-1, m_BinTreeFormat.m_pFormatConst->m_strFaceName);
	m_ComboFontNum.SelectString(-1, m_BinTreeFormat.m_pFormatNum->m_strFaceName);
	m_ComboFontFunc.SelectString(-1, m_BinTreeFormat.m_pFormatFunc->m_strFaceName);

	// set the formula control to read only mode
	m_PreviewCtrl.SetReadOnly(TRUE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CFormulaSettingsDlg::SetupPreviewTree()
{
	//Create some Data for the preview window
	CNode* pParent;
	// =
	pParent=m_BinTree.CreateTree(NT_EQUATION);
	// F
	pParent->SetLeftChild(m_BinTree.CreateNode(NT_VARIABLE));
	pParent->GetLeftChild()->SetShortCut("F");
	// *
	pParent->SetRightChild(m_BinTree.CreateNode(NT_TIMES));
	// gamma
	pParent->GetRightChild()->SetLeftChild(m_BinTree.CreateNode(NT_CONSTANT));
	pParent->GetRightChild()->GetLeftChild()->SetShortCut("W");
	pParent->GetRightChild()->GetLeftChild()->SetFaceName("Symbol");
	// over
	pParent->GetRightChild()->SetRightChild(m_BinTree.CreateNode(NT_DIVISION));
	// *
	pParent->GetRightChild()->GetRightChild()->SetLeftChild(m_BinTree.CreateNode(NT_TIMES));
	// sum
	pParent->GetRightChild()->GetRightChild()->GetLeftChild()->SetLeftChild(m_BinTree.CreateNode(NT_SUM));
	// infinity
	pParent->GetRightChild()->GetRightChild()->GetLeftChild()->GetLeftChild()->GetLeftChild()->SetLeftChild(m_BinTree.CreateNode(NT_INFINITY));
	// i=0
	pParent->GetRightChild()->GetRightChild()->GetLeftChild()->GetLeftChild()->GetLeftChild()->SetRightChild(m_BinTree.CreateNode(NT_EQUATION));
	pParent->GetRightChild()->GetRightChild()->GetLeftChild()->GetLeftChild()->GetLeftChild()->GetRightChild()->SetRightChild(m_BinTree.CreateNode(NT_NUMBER));
	pParent->GetRightChild()->GetRightChild()->GetLeftChild()->GetLeftChild()->GetLeftChild()->GetRightChild()->GetRightChild()->SetShortCut("0");
	pParent->GetRightChild()->GetRightChild()->GetLeftChild()->GetLeftChild()->GetLeftChild()->GetRightChild()->SetLeftChild(m_BinTree.CreateNode(NT_VARIABLE));
	pParent->GetRightChild()->GetRightChild()->GetLeftChild()->GetLeftChild()->GetLeftChild()->GetRightChild()->GetLeftChild()->SetShortCut("i");
	// m
	pParent->GetRightChild()->GetRightChild()->GetLeftChild()->GetLeftChild()->SetRightChild(m_BinTree.CreateNode(NT_VARIABLE));
	pParent->GetRightChild()->GetRightChild()->GetLeftChild()->GetLeftChild()->GetRightChild()->SetShortCut("m");
	// index
	pParent->GetRightChild()->GetRightChild()->GetLeftChild()->GetLeftChild()->GetRightChild()->SetRightChild(m_BinTree.CreateNode(NT_INDEX));
	// i, j
	pParent->GetRightChild()->GetRightChild()->GetLeftChild()->GetLeftChild()->GetRightChild()->GetRightChild()->SetRightChild(m_BinTree.CreateNode(NT_VARIABLE));
	pParent->GetRightChild()->GetRightChild()->GetLeftChild()->GetLeftChild()->GetRightChild()->GetRightChild()->GetRightChild()->SetShortCut("i, j");
	// k
	pParent->GetRightChild()->GetRightChild()->GetLeftChild()->SetRightChild(m_BinTree.CreateNode(NT_VARIABLE));
	pParent->GetRightChild()->GetRightChild()->GetLeftChild()->GetRightChild()->SetShortCut("k");
	// sin
	pParent->GetRightChild()->GetRightChild()->SetRightChild(m_BinTree.CreateNode(NT_FUNC));
	// ()
	pParent->GetRightChild()->GetRightChild()->GetRightChild()->SetRightChild(m_BinTree.CreateNode(NT_BRACE));
	// power to
	pParent->GetRightChild()->GetRightChild()->GetRightChild()->GetRightChild()->SetLeftChild(m_BinTree.CreateNode(NT_POWERTO));
	// r
	pParent->GetRightChild()->GetRightChild()->GetRightChild()->GetRightChild()->GetLeftChild()->SetLeftChild(m_BinTree.CreateNode(NT_CONSTANT));
	pParent->GetRightChild()->GetRightChild()->GetRightChild()->GetRightChild()->GetLeftChild()->GetLeftChild()->SetShortCut("r");
	// 2
	pParent->GetRightChild()->GetRightChild()->GetRightChild()->GetRightChild()->GetLeftChild()->SetRightChild(m_BinTree.CreateNode(NT_NUMBER));
	pParent->GetRightChild()->GetRightChild()->GetRightChild()->GetRightChild()->GetLeftChild()->GetRightChild()->SetShortCut("2");
}

void CFormulaSettingsDlg::OnOK() 
{
	// get the data from the control member vars, before calling OnOK
	m_ComboFontVar.GetWindowText(m_BinTreeFormat.m_pFormatVar->m_strFaceName);
	m_ComboFontConst.GetWindowText(m_BinTreeFormat.m_pFormatConst->m_strFaceName);
	m_ComboFontNum.GetWindowText(m_BinTreeFormat.m_pFormatNum->m_strFaceName);
	m_ComboFontFunc.GetWindowText(m_BinTreeFormat.m_pFormatFunc->m_strFaceName);

	CDialog::OnOK();
}

LONG CFormulaSettingsDlg::OnSelEndOK(UINT lParam, LONG wParam)
{
    UpdatePreview();
	return 0L;
}

void CFormulaSettingsDlg::UpdatePreview() 
{
	TRACE("UpdatePreview()\n");
	//Get the data
	if(UpdateData(TRUE))
	{
		// if all data is ok, update the tre and the control
		m_ComboFontVar.GetWindowText(m_BinTreeFormat.m_pFormatVar->m_strFaceName);
		m_ComboFontConst.GetWindowText(m_BinTreeFormat.m_pFormatConst->m_strFaceName);
		m_ComboFontNum.GetWindowText(m_BinTreeFormat.m_pFormatNum->m_strFaceName);
		m_ComboFontFunc.GetWindowText(m_BinTreeFormat.m_pFormatFunc->m_strFaceName);
		
		m_BinTree.ReformatNodes(&m_BinTreeFormat);
		m_PreviewCtrl.Invalidate(TRUE);
	}
}

void CFormulaSettingsDlg::OnKillfocusEdit() 
{
	//Get the data
	if(UpdateData(TRUE))
	{
		// if all data is ok, update the tre and the control
		m_BinTree.ReformatNodes(&m_BinTreeFormat);
		m_PreviewCtrl.Invalidate(TRUE);
	}
}
